<launch>

  <!-- Robot pose. -->
  <arg name="x" default="0"/>
  <arg name="y" default="0"/>
  <arg name="z" default="1.55"/>
  <arg name="roll" default="0"/>
  <arg name="pitch" default="0"/>
  <arg name="yaw" default="0"/>

  <!-- Parameterized model name. Can change from cmd line, but likely keep default. -->
  <arg name="robot_name" default="lleap_exo" />
  <arg name="descPath" value="(find $(arg robot_name)_description)" />
  <arg name="configPath" value="(find $(arg robot_name)_launch)" />
  <arg name="dollar" value="$" />
  <arg
    name="model"
    default="$(arg dollar)$(arg descPath)/urdf/$(arg robot_name).urdf.xacro" />

  <!-- Upload robot model to Param Server. Parse xacro. Use the 'inorder' tag  (with 2 dashes
        in front of the tag itself) to parse in read order instead. -->
  <param
    name="robot_description"
    command="$(find xacro)/xacro $(arg model)" />

  <!-- Pick Gazebo world to be the empty world. -->
  <include
    file="$(find gazebo_ros)/launch/empty_world.launch" />
  
  <!-- this  establishes the static transform between these 2 frames, world -> base_link.
    Don't need to do this manually in Gazebo version, only for TF in rviz launch.
    "base_link has its origin directly at the pivot point or center of the robot. This 
      coordinate frame moves as the robot moves."
    https://automaticaddison.com/coordinate-frames-and-transforms-for-ros-based-mobile-robots/#:~:text=base_footprint%20has%20its%20origin%20directly,or%20center%20of%20the%20robot.
    base_link should be the bottom of the torso (in URDF model).

    Was base_link <- base_footprint would only be used by tf, and rn it is not used at all. 
      Could be later if we start treating the exo more like a mobile robot (imagine the 
      base_footprint literally as the robot's image/shadow/footprint of space on the ground).
  -->
  <!--
  <node
    name="tf_base"
    pkg="tf"
    type="static_transform_publisher"
    args="0 0 0 0 0 0 world base_link 40" />
  -->
  
  <!-- Spawn model in Gazebo. Default: held above ground (z shift). -->
  <node
    name="spawn_model"
    pkg="gazebo_ros"
    type="spawn_model"
    args="-urdf -model robot -param robot_description
          -x $(arg x) -y $(arg y) -z $(arg z) -R $(arg roll) -P $(arg pitch) -Y $(arg yaw)"
    output="screen" />
  
  <!-- TODO: Look at ros_control stuff to figure out what this is doing, why, and if we need it. -->
  <node
    name="fake_joint_calibration"
    pkg="rostopic"
    type="rostopic"
    args="pub /calibrated std_msgs/Bool true" />
  
  <!-- Load joint controller configurations from YAML file to Param Server. -->
  <rosparam file="$(arg dollar)$(arg configPath)/config/$(arg robot_name)_control.yaml" command="load"/>

  <!-- Load the controllers. -->
  <node name="controller_spawner" pkg="controller_manager" type="spawner" respawn="false"
    output="screen" ns="/$(arg robot_name)" args="joint_state_controller 
                                                right_joint_group_position_controller
                                                left_joint_group_position_controller"/>

  <!-- Convert joint states to TF transforms for rviz, etc. -->
  <node name="robot_state_publisher" pkg="robot_state_publisher" type="robot_state_publisher"
    respawn="false" output="screen">
    <!-- Remap input topic: should look in robot namespace, not in raw (which will still show in topic list). -->
    <remap from="/joint_states" to="/$(arg robot_name)/joint_states" />
  </node>

</launch>